declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE PERSON_ENTITLEMENT_RISK_SCORE
  (
    PERSON_ID 					VARCHAR(128) 	NOT NULL,  
    EXTERNAL_PERSON_ID 			VARCHAR(128),
    ENTITLEMENT_ID				VARCHAR(128)	NOT NULL,
	EXTERNAL_ENTITLEMENT_ID 	VARCHAR(128),
	ACCOUNT_ID 					VARCHAR(128)	NOT NULL,
	EXTERNAL_ACCOUNT_ID			VARCHAR(128),
	APPLICATION_ID				VARCHAR(128)	NOT NULL,
	EXTERNAL_APPLICATION_ID		VARCHAR(128),
	RISKSCORE		 			NUMERIC(7,3),
    LAST_MOD_TIME		  		VARCHAR(128)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE PERSON_ENTITLEMENT_RISK_SCORE
    ADD CONSTRAINT PERSON_ENT_RISK_SCORE_PK
    PRIMARY KEY (PERSON_ID, ENTITLEMENT_ID, ACCOUNT_ID, APPLICATION_ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE PERSON_ENTITLEMENT_RISK_SCORE' );

GRANT ALL ON PERSON_ENTITLEMENT_RISK_SCORE TO IGA;

