declare
  stat        varchar(2048);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE TABLE ENTITY_DELETED_PREFERENCE
  (
    ID 			NUMERIC(16) 	NOT NULL,  
    PID 		VARCHAR(512) 	NOT NULL,
    TYPE 		VARCHAR(64),
    PARAM1  	VARCHAR(64)
  )
  IN &DATA_TABLESPACE
  INDEX IN &INDEX_TABLESPACE
  LONG IN &LOB_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42889'); -- PK already defined

begin
  stat := '
  ALTER TABLE ENTITY_DELETED_PREFERENCE
    ADD CONSTRAINT ENTITY_DELETED_PREF_PK
    PRIMARY KEY (ID)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'01550'); -- index already existing

begin
  stat := '
  CREATE UNIQUE INDEX ENTITY_DELETED_PID_IDX ON ENTITY_DELETED_PREFERENCE
  (PID ASC)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

CALL SYSPROC.ADMIN_CMD ( 'REORG TABLE ENTITY_DELETED_PREFERENCE' );

GRANT ALL ON ENTITY_DELETED_PREFERENCE TO IGA;

declare
  stat        varchar(256);
  exception1  EXCEPTION;
  PRAGMA DB2_EXCEPTION_INIT(exception1,'42710'); -- The name of the object to be created is identical to the existing name

begin
  stat := '
  CREATE SEQUENCE ENTITY_DELETED_PREFERENCE_SEQ
    AS NUMERIC(18)
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999
    NO CACHE
    NO CYCLE
    NO ORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/
GRANT USAGE ON SEQUENCE ENTITY_DELETED_PREFERENCE_SEQ TO IGA;
