declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat :=' 
 CREATE TABLE EMPLOYMENT_REVIEW_PWDMAN_H
(
  ID                             NUMBER(16)          NOT NULL,
  EMPLOYMENT_REVIEW_H            NUMBER(16)          NOT NULL,
  PWDMANAGEMENT_CODE             VARCHAR2(256 CHAR),
  IS_DEFAULT                   	 NUMBER(1),
  PWDCFG_NAME 			 VARCHAR2(256 CHAR),
  PWDCFG_DESCRIPTION 		 VARCHAR2(256 CHAR),
  ATTR1                          VARCHAR2(256 CHAR),
  ATTR2                          VARCHAR2(256 CHAR),
  ATTR3                          VARCHAR2(256 CHAR),
  ATTR4                          VARCHAR2(256 CHAR),
  ATTR5                          VARCHAR2(256 CHAR),
  ATTR6                          VARCHAR2(256 CHAR),
  ATTR7                          VARCHAR2(256 CHAR),
  ATTR8                          VARCHAR2(256 CHAR),
  ATTR9                          VARCHAR2(256 CHAR),
  ATTR10                         VARCHAR2(256 CHAR)
 
)
TABLESPACE &DATA_TABLESPACE
';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN_H
    ADD CONSTRAINT EMPLOYMENT_REV_PWDMAN_H_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02275); -- such a referential constraint already exists in the table

begin
  stat := '
 ALTER TABLE EMPLOYMENT_REVIEW_PWDMAN_H ADD (
  CONSTRAINT EMP_REV_PWDM_H_EMP_REV_H_FK
 FOREIGN KEY (EMPLOYMENT_REVIEW_H)
 REFERENCES EMPLOYMENT_REVIEW_H (ID)
    ON DELETE CASCADE)
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_H TO IDEAS;
GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_H TO IDEAS_CONNECTOR;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN_H TO IDEAS_REPORT;


declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE EMPLOYMENT_REVIEW_PWDMAN_H_SEQ
  START WITH 100
  INCREMENT BY 1
  MINVALUE 100
  MAXVALUE 999999999999999999999999999
  NOCACHE
  NOCYCLE
  NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_H_SEQ TO IDEAS;
GRANT ALL ON EMPLOYMENT_REVIEW_PWDMAN_H_SEQ TO IDEAS_CONNECTOR;
GRANT SELECT ON EMPLOYMENT_REVIEW_PWDMAN_H_SEQ TO IDEAS_REPORT;

