CREATE OR REPLACE TRIGGER TRG_USER_EVENT_ERC_EVENT_OUT 
	AFTER UPDATE OR DELETE ON USER_EVENT_ERC 
	FOR EACH ROW 
		DECLARE 
		feedback_status NUMERIC(16);
		counter NUMBER(16);
BEGIN
IF ( updating
AND ( :new.status IS NULL
OR ( :new.status = :old.status )
OR :new.event_out IS NULL ) ) THEN RETURN;
END IF;

IF ( deleting
AND ( :old.status IS NULL
OR :old.event_out IS NULL ) ) THEN RETURN;
END IF;

IF (updating) THEN UPDATE
    event_out
SET
    erc_status = :new.status,
    trace = :new.trace
WHERE
    id = :new.event_out;

IF ( :new.operation IN ( 1,
2,
6,
7,
11 ) ) THEN IF ( :new.status = 1 ) THEN feedback_status := 1;

elsif ( :new.status >= 2 ) THEN feedback_status := 2;
ELSE feedback_status := -1;
END IF;

IF ( feedback_status <> -1 ) THEN IF ( :new.operation IN ( 1,
2 ) ) THEN SELECT
    COUNT(1) INTO
        counter
    FROM
        feedback
    WHERE
        LOWER (funct_application) = LOWER ( :new.application )
        AND LOWER (APPLICATION) = LOWER ( :new.target )
        AND LOWER (funct_type) = LOWER ( :new.attr2 )
        AND LOWER (funct) = LOWER ( :new.attr1 )
        AND LOWER (cod_operation) = LOWER ( :new.cod_operation )
        AND operation = :new.operation
        AND user_erc = :new.user_erc;

elsif ( :new.operation IN ( 6,
7 ) ) THEN SELECT
    COUNT(1) INTO
        counter
    FROM
        feedback
    WHERE
        LOWER (APPLICATION) = LOWER ( :new.target )
        AND LOWER (cod_operation) = LOWER ( :new.cod_operation )
        AND operation = :new.operation
        AND user_erc = :new.user_erc;

elsif ( :new.operation = 11 ) THEN SELECT
    COUNT(1) INTO
        counter
    FROM
        feedback,
        pwdmanagement
    WHERE
        LOWER (APPLICATION) = LOWER ( :new.target )
        AND LOWER (cod_operation) = LOWER ( :new.cod_operation )
        AND operation = :new.operation
        AND user_erc = :new.user_erc
        AND authorizations = pwdmanagement.id
        AND LOWER (pwdmanagement.code) = LOWER ( :new.user_id );
END IF;

IF ( counter = 1 ) THEN IF ( :new.operation IN ( 1,
2 ) ) THEN UPDATE
    feedback
SET
    status = feedback_status
WHERE
    LOWER (funct_application) = LOWER ( :new.application )
    AND LOWER (APPLICATION) = LOWER ( :new.target )
    AND LOWER (funct_type) = LOWER ( :new.attr2 )
    AND LOWER (funct) = LOWER ( :new.attr1 )
    AND LOWER (cod_operation) = LOWER ( :new.cod_operation )
    AND operation = :new.operation
    AND user_erc = :new.user_erc;

elsif ( :new.operation IN ( 6,
7 ) ) THEN UPDATE
    feedback
SET
    status = feedback_status
WHERE
    LOWER (APPLICATION) = LOWER ( :new.target )
    AND LOWER (cod_operation) = LOWER ( :new.cod_operation )
    AND operation = :new.operation
    AND user_erc = :new.user_erc;

elsif ( :new.operation = 11 ) THEN UPDATE
    feedback
SET
    status = feedback_status
WHERE
    LOWER (APPLICATION) = LOWER ( :new.target )
    AND LOWER (cod_operation) = LOWER ( :new.cod_operation )
    AND operation = :new.operation
    AND user_erc = :new.user_erc
    AND authorizations IN (
        SELECT pwdmanagement.id
    FROM
        pwdmanagement
    WHERE
        LOWER (code) = LOWER ( :new.user_id ));
END IF;
END IF;
END IF;
END IF;

elsif (deleting) THEN UPDATE
    event_out
SET
    erc_status = :old.status,
    trace = :old.trace
WHERE
    id = :old.event_out;

IF ( :old.operation IN ( 1,
2,
6,
7,
8,
11 ) ) THEN IF ( :old.status = 1 ) THEN feedback_status := 1;

elsif ( :old.status >= 2 ) THEN feedback_status := 2;
ELSE feedback_status := -1;
END IF;

IF ( feedback_status <> -1 ) THEN IF ( :old.operation IN ( 1,
2 ) ) THEN SELECT
    COUNT(1) INTO
        counter
    FROM
        feedback
    WHERE
        LOWER (funct_application) = LOWER ( :old.application )
        AND LOWER (APPLICATION) = LOWER ( :old.target )
        AND LOWER (funct_type) = LOWER ( :old.attr2 )
        AND LOWER (funct) = LOWER ( :old.attr1 )
        AND LOWER (cod_operation) = LOWER ( :old.cod_operation )
        AND operation = :old.operation
        AND user_erc = :old.user_erc;

elsif ( :old.operation IN ( 6,
7,8 ) ) THEN SELECT
    COUNT(1) INTO
        counter
    FROM
        feedback
    WHERE
        LOWER (APPLICATION) = LOWER ( :old.target )
        AND LOWER (cod_operation) = LOWER ( :old.cod_operation )
        AND operation = :old.operation
        AND user_erc = :old.user_erc;

elsif ( :old.operation = 11 ) THEN SELECT
    COUNT(1) INTO
        counter
    FROM
        feedback,
        pwdmanagement
    WHERE
        LOWER (APPLICATION) = LOWER ( :old.target )
        AND LOWER (cod_operation) = LOWER ( :old.cod_operation )
        AND operation = :old.operation
        AND user_erc = :old.user_erc
        AND authorizations = pwdmanagement.id
        AND LOWER (pwdmanagement.code) = LOWER ( :old.user_id );
END IF;

IF ( counter = 1 ) THEN IF ( :old.operation IN ( 1,
2 ) ) THEN UPDATE
    feedback
SET
    status = feedback_status
WHERE
    LOWER (funct_application) = LOWER ( :old.application )
    AND LOWER (APPLICATION) = LOWER ( :old.target )
    AND LOWER (funct_type) = LOWER ( :old.attr2 )
    AND LOWER (funct) = LOWER ( :old.attr1 )
    AND LOWER (cod_operation) = LOWER ( :old.cod_operation )
    AND operation = :old.operation
    AND user_erc = :old.user_erc;

elsif ( :old.operation IN ( 6,
7, 8 ) ) THEN UPDATE
    feedback
SET
    status = feedback_status
WHERE
    LOWER (APPLICATION) = LOWER ( :old.target )
    AND LOWER (cod_operation) = LOWER ( :old.cod_operation )
    AND operation = :old.operation
    AND user_erc = :old.user_erc;

elsif ( :old.operation = 11 ) THEN UPDATE
    feedback
SET
    status = feedback_status
WHERE
    LOWER (APPLICATION) = LOWER ( :old.target )
    AND LOWER (cod_operation) = LOWER ( :old.cod_operation )
    AND operation = :old.operation
    AND user_erc = :old.user_erc
    AND authorizations IN (
        SELECT pwdmanagement.id
    FROM
        pwdmanagement
    WHERE
        LOWER (code) = LOWER ( :old.user_id ));
END IF;
END IF;
END IF;
END IF;
END IF;
END TRG_USER_EVENT_ERC_EVENT_OUT;
/