	CREATE OR REPLACE
	TRIGGER TRG_PWDMANAGEMENT_BEFORE BEFORE INSERT
		OR UPDATE
			ON
			PWDMANAGEMENT FOR EACH ROW DECLARE cur_pwdcfg sys_refcursor;

	feedB BOOLEAN;

	v_target VARCHAR(256);

	code_oper VARCHAR(128);

	oldpwd VARCHAR(128);

	newpwd VARCHAR(128);

	olduserid VARCHAR(128);

	newuserid VARCHAR(128);

	oldexpire VARCHAR(128);

	newexpire VARCHAR(128);

	oldchangelog NUMBER(16);

	newchangelog NUMBER(16);

	currentchangelog NUMBER(16);

	counter NUMBER(16);

	disoper NUMBER(16);
	BEGIN
	IF ( :new.person IS NULL ) THEN RETURN;
	END IF;

	IF ( updating
	AND ( ( :old.CHALLENGE_COUNTER != :new.CHALLENGE_COUNTER )
	OR ( :old.CHALLENGE_COUNTER IS NULL
	AND :new.CHALLENGE_COUNTER IS NOT NULL )
	OR ( :old.CHALLENGE_COUNTER IS NOT NULL
	AND :new.CHALLENGE_COUNTER IS NULL ) ) ) THEN RETURN;
	END IF;

	IF ( updating
	AND ( ( :old.CHALLENGE_FAILED_ATTEMPT != :new.CHALLENGE_FAILED_ATTEMPT )
	OR ( :old.CHALLENGE_FAILED_ATTEMPT IS NULL
	AND :new.CHALLENGE_FAILED_ATTEMPT IS NOT NULL )
	OR ( :old.CHALLENGE_FAILED_ATTEMPT IS NOT NULL
	AND :new.CHALLENGE_FAILED_ATTEMPT IS NULL ) ) ) THEN RETURN;
	END IF;

	IF ( updating
	AND ( ( :old.CHALLENGE_TOKEN != :new.CHALLENGE_TOKEN )
	OR ( :old.CHALLENGE_TOKEN IS NULL
	AND :new.CHALLENGE_TOKEN IS NOT NULL )
	OR ( :old.CHALLENGE_TOKEN IS NOT NULL
	AND :new.CHALLENGE_TOKEN IS NULL ) ) ) THEN RETURN;
	END IF;

	IF ( updating
	AND ( ( :old.CHALLENGE_TOKEN_CREATION != :new.CHALLENGE_TOKEN_CREATION )
	OR ( :old.CHALLENGE_TOKEN_CREATION IS NULL
	AND :new.CHALLENGE_TOKEN_CREATION IS NOT NULL )
	OR ( :old.CHALLENGE_TOKEN_CREATION IS NOT NULL
	AND :new.CHALLENGE_TOKEN_CREATION IS NULL ) ) ) THEN RETURN;
	END IF;

	SELECT
		COUNT(1) INTO
			counter
		FROM
			tmp_codoperation;

	IF ( counter = 0 ) THEN RAISE_APPLICATION_ERROR ( -20200,
	'NO OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');

	elsif ( counter = 1 ) THEN SELECT
		code INTO
			code_oper
		FROM
			tmp_codoperation;

	elsif ( counter > 1 ) THEN RAISE_APPLICATION_ERROR ( -20201,
	'TOO MANY OPERATION CODE FOUND IN TMP_CODOPERATION TABLE');
	END IF;

	IF (code_oper IS NOT NULL
	AND INSTR(code_oper,
	'ARM_',
	1,
	1) = 1) THEN feedB := TRUE;
	ELSE feedB := FALSE;
	END IF;

	IF (inserting) THEN
	-- attr1 contiene la password cifrata. Attr2 contiene il codice di blocco
	 INSERT
		INTO
			eventpm (id,
			person,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr2,
			attr3,
			attr5,
			changelog)
		VALUES (eventpm_seq.nextval,
		:new.person,
		code_oper,
		8,
		:new.pwdcfg,
		:new.code,
		:new.attr1,
		:new.attr2,
		:new.id,
		:new.changelog);
	-- if the account is disabled on create (block code on attr 2 is not equal to 000000)
	-- we must insert another event of disable user to account provisioning
	 IF (:new.attr2 IS NOT NULL
	AND :new.attr2 != '000000') THEN
	--account disabled event
	 INSERT
		INTO
			eventpm (id,
			person,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr3,
			attr5)
		VALUES (eventpm_seq.nextval,
		:new.person,
		code_oper,
		6,
		:new.pwdcfg,
		:new.code,
		:new.attr2,
		:new.id);
	END IF;
	--2015-09-09 - Only in case of account with an expiration, put another entry in event_pm table
	 IF ( :new.expire IS NOT NULL ) THEN INSERT
		INTO
			eventpm (id,
			person,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr2,
			attr5)
		VALUES (eventpm_seq.nextval,
		:new.person,
		code_oper,
		10,
		:new.pwdcfg,
		:new.code,
		:new.expire,
		:new.id);
	END IF;
	-- cancelliamo la password cifrata per connettore
	:new.attr1 := NULL;


--manage the insert account for feedback 
		IF (feedB) THEN OPEN cur_pwdcfg FOR SELECT
			DISTINCT t.value
		FROM
			pwdcfg pwd,
			target t
		WHERE
			pwd.id = :new.pwdcfg
			AND pwd.id = t.pwdcfg
			AND pwd.sync = 2;

		LOOP FETCH cur_pwdcfg INTO
			v_target;
		EXIT
		WHEN cur_pwdcfg % NOTFOUND;
		-- controllo del target
 IF (v_target IS NOT NULL) THEN INSERT
    INTO
        feedback (id,
        authorizations,
        APPLICATION,
        cod_operation,
        operation)
    VALUES (feedback_seq.nextval,
    :new.id,
    v_target,
    code_oper,
    8);
END IF;
END LOOP;

CLOSE cur_pwdcfg;
END IF;
-- end manage the insert account for feedback
	RETURN;
	END IF;

	IF (updating) THEN oldpwd := :old.password;

	newpwd := :new.password;

	olduserid := :old.code;

	newuserid := :new.code;

	oldexpire := :old.expire;

	newexpire := :new.expire;

	oldchangelog := :old.changelog;

	newchangelog := :new.changelog;

	currentchangelog := NULL;
	END IF;
	-- pwd
	 IF (oldpwd IS NULL) THEN oldpwd := '_';
	END IF;

	IF (newpwd IS NULL) THEN newpwd := '_';
	END IF;
	--- userid
	 IF (olduserid IS NULL) THEN olduserid := '_';
	END IF;

	IF (newuserid IS NULL) THEN newuserid := '_';
	END IF;
	--- changelog
	 IF (oldchangelog IS NULL) THEN oldchangelog := 0;
	END IF;

	IF (newchangelog IS NULL) THEN newchangelog := 0;
	END IF;

	IF (oldchangelog != newchangelog) THEN currentchangelog := newchangelog;
	END IF;

	IF (olduserid != newuserid
	OR oldchangelog != newchangelog) THEN INSERT
		INTO
			eventpm (id,
			person,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr4,
			attr5,
			changelog)
		VALUES (eventpm_seq.nextval,
		:new.person,
		code_oper,
		10,
		:new.pwdcfg,
		newuserid,
		olduserid,
		:new.id,
		currentchangelog);
	END IF;

	IF (oldpwd != newpwd
	OR :new.attr1 IS NOT NULL) THEN INSERT
		INTO
			eventpm (id,
			person,
			authorizations,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr2,
			attr5)
		VALUES (eventpm_seq.nextval,
		:new.person,
		:new.id,
		code_oper,
		11,
		:new.pwdcfg,
		newuserid,
		:new.attr1,
		:new.id);
	-- propago su feedback solo in caso di cambio password da swim
	 IF (feedB) THEN OPEN cur_pwdcfg FOR SELECT
		DISTINCT t.value
	FROM
		pwdcfg pwd,
		target t
	WHERE
		pwd.id = :new.pwdcfg
		AND pwd.id = t.pwdcfg
		AND pwd.sync = 2;

	LOOP FETCH cur_pwdcfg INTO
		v_target;

	EXIT
	WHEN cur_pwdcfg % NOTFOUND;
	-- controllo del target
	 IF (v_target IS NOT NULL) THEN INSERT
		INTO
			feedback (id,
			authorizations,
			APPLICATION,
			cod_operation,
			operation)
		VALUES (feedback_seq.nextval,
		:new.id,
		v_target,
		code_oper,
		11);
	END IF;
	END LOOP;

	CLOSE cur_pwdcfg;
	-- fine propagazione su feedback
	END IF;
	-- cancelliamo la password cifrata per connettore
	:new.attr1 := NULL;
	END IF;

	IF (oldexpire != newexpire) THEN INSERT
		INTO
			eventpm (id,
			person,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr2,
			attr5,
			changelog)
		VALUES (eventpm_seq.nextval,
		:new.person,
		code_oper,
		10,
		:new.pwdcfg,
		newuserid,
		newexpire,
		:new.id,
		currentchangelog);
	END IF;

	IF (:old.disabled <> :new.disabled) THEN disoper := 7;

	IF (:new.disabled = 1) THEN disoper := 6;
	END IF;
	--disabilita/abilita utente
	 INSERT
		INTO
			eventpm (id,
			person,
			cod_operation,
			operation,
			pwdcfg,
			attr1,
			attr3,
			attr5)
		VALUES (eventpm_seq.nextval,
		:new.person,
		code_oper,
		disoper,
		:new.pwdcfg,
		newuserid,
		:new.attr2,
		:new.id);
	-- 2016-03-07
	-- propago su feedback solo in caso il blocco/sblocco account provenga da swim
	 IF (feedB) THEN OPEN cur_pwdcfg FOR SELECT
		DISTINCT t.value
	FROM
		pwdcfg pwd,
		target t
	WHERE
		pwd.id = :new.pwdcfg
		AND pwd.id = t.pwdcfg
		AND pwd.sync = 2;

	LOOP FETCH cur_pwdcfg INTO
		v_target;

	EXIT
	WHEN cur_pwdcfg % NOTFOUND;
	-- controllo del target
	 IF (v_target IS NOT NULL) THEN INSERT
		INTO
			feedback (id,
			authorizations,
			APPLICATION,
			cod_operation,
			operation)
		VALUES (feedback_seq.nextval,
		:new.id,
		v_target,
		code_oper,
		disoper);
	END IF;
	END LOOP;

	CLOSE cur_pwdcfg;
	-- fine propagazione su feedback
	END IF;
	END IF;
	END TRG_PWDMANAGEMENT_BEFORE;
	/
