declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE PERSON_ENTITLEMENT_RISK_SCORE
  (
    PERSON_ID 					VARCHAR2(128) 	NOT NULL,  
    EXTERNAL_PERSON_ID 			VARCHAR2(128),
    ENTITLEMENT_ID				VARCHAR2(128)	NOT NULL,
	EXTERNAL_ENTITLEMENT_ID 	VARCHAR2(128),
	ACCOUNT_ID 					VARCHAR2(128)	NOT NULL,
	EXTERNAL_ACCOUNT_ID			VARCHAR2(128),
	APPLICATION_ID				VARCHAR2(128)	NOT NULL,
	EXTERNAL_APPLICATION_ID		VARCHAR2(128),
	RISKSCORE		 			NUMBER(7,3),
    LAST_MOD_TIME		  		VARCHAR2(128)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE PERSON_ENTITLEMENT_RISK_SCORE
    ADD CONSTRAINT PERSON_ENT_RISK_SCORE_PK PRIMARY KEY (PERSON_ID, ENTITLEMENT_ID, ACCOUNT_ID, APPLICATION_ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/


GRANT ALL ON PERSON_ENTITLEMENT_RISK_SCORE TO IDEAS;
