declare
  attestation_id      number(16);
  view_conf_name      varchar2(128);
  view_conf_position  number(16);
  view_conf_id        number(16);
  view_conf_visible   number(16);
  v_name              varchar2(128);

  counter             number(16);
  cur_attest          sys_refcursor;

begin
  ------ENTITLEMENT_VIEW SECTION
  v_name := 'Entitlement_View';
  
  open cur_attest for
  select att.id from attestation att where type=1 and state not in (5, 10); 
    loop
    fetch cur_attest into attestation_id;
    exit when cur_attest%NOTFOUND;
    
	view_conf_name := 'UE_TABULAR_ATTESTATION_BUTTONS';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_USER_ID';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if; 
    
    view_conf_name := 'UE_TABULAR_USER_NAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_USER_SURNAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_USER_INFO_BUTTON';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_OU_NAME_CODE';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_APP_NAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_ENT_NAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_EMPLOYMENT_ACCOUNT';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_ENT_CODE';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_ENT_DESC';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_ENT_INFO_BUTTON';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_ENT_INFO_BUTTON';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_VISIBILITY_VIOLATION';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_USER_TYPE';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_OU_DESC';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_OU_OWNER';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_APP_DESC';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_APP_OWNER';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_GROUP_NAME_CODE';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_HIERARCHY_NAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
      
    view_conf_name := 'UE_TABULAR_RISK';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_UME';
    view_conf_visible := 0;
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_TABULAR_RISK_SCORE';
    view_conf_visible := 0;
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'User_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    end loop;
  close cur_attest;
------END OF ENTITLEMENT_VIEW SECTION
  
  
  ------USER_VIEW SECTION
  v_name := 'User_View';
  
  open cur_attest for
  select att.id from attestation att where type=1 and state not in (5, 10); 
    loop
     fetch cur_attest into attestation_id;
     exit when cur_attest%NOTFOUND;
     
    view_conf_name := 'UE_DETAILS_ATTESTATION_BUTTONS';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_USER_ID';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_USER_NAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_USER_SURNAME';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_USER_TYPE';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_OU_NAME_CODE';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_USER_SEX';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_DOB';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_ADDRESS';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_EMAIL';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_DN';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_NATION';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_ZIPCODE';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_COUNTRY';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_PHONE_NUMBER';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_OWNER_CODE';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
      
    view_conf_name := 'UE_DETAILS_RISK';
  	view_conf_visible := 1;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_UME';
    view_conf_visible := 1;
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_RISK_SCORE';
    view_conf_visible := 0;
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
     
    view_conf_name := 'UE_DETAILS_ATTR1';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_ATTR2';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_ATTR3';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
	view_conf_name := 'UE_DETAILS_ATTR4';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
    
    view_conf_name := 'UE_DETAILS_ATTR5';
  	view_conf_visible := 0;  
    select count(1) into counter from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    if ( counter = 0 or counter > 1) then
    	delete from attestation_view attview where attview.field = view_conf_name and attview.attestation = attestation_id;
    	select attestation_view_seq.nextval into view_conf_id from dual;
    	select ( max(t.position) + 1 ) into view_conf_position from attestation_view t where t.attestation = attestation_id and ( view_name is null or view_name <> 'Entitlement_View' );
    	if( view_conf_position is null ) then
    		view_conf_position := 1;
    	end if;
        insert into attestation_view (id, attestation, field, position, visible, view_name)
   	 	values (view_conf_id, attestation_id, view_conf_name, view_conf_position, view_conf_visible, v_name);
    else
    	update attestation_view t set t.view_name = v_name, t.state = 0 where t.attestation = attestation_id and t.field = view_conf_name;
   	end if;
   
    end loop;
  close cur_attest;
 
end;
/
commit;
