declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE ENTITY_DELETED_PREFERENCE
  (
    ID 			NUMBER(16) 		NOT NULL,  
    PID 		VARCHAR2(512) 	NOT NULL,
    TYPE 		VARCHAR2(64),
    PARAM1	  	VARCHAR2(64)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE ENTITY_DELETED_PREFERENCE
    ADD CONSTRAINT ENTITY_DELETED_PREF_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE UNIQUE INDEX ENTITY_DELETED_PID_IDX ON ENTITY_DELETED_PREFERENCE 
  (PID ASC) 
  REVERSE
  NOLOGGING
  NOPARALLEL
  TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON ENTITY_DELETED_PREFERENCE TO IDEAS;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE ENTITY_DELETED_PREFERENCE_SEQ
    START WITH 100
    INCREMENT BY 1
    MINVALUE 100
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON ENTITY_DELETED_PREFERENCE_SEQ TO IDEAS;
