set define off
declare
  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fevt_id       number(16);
  fevt_name     varchar2(256) := 'TARGET';
  
  f_id          number(16);
  f_name        varchar2(256) := 'ROLE_CREATE';

  f_lob         clob := 'package te0b9aeda
'||'import com.engiweb.profilemanager.backend.business.direct.ApplicationDirect
'||'import com.engiweb.profilemanager.backend.business.direct.ExternalRoleDirect
'||'import com.engiweb.profilemanager.common.bean.FunctionalityTypeBean
'||'import com.engiweb.profilemanager.common.bean.entitlement.EntitlementBean
'||'import com.engiweb.profilemanager.common.bean.event.EntStateBean
'||'import com.engiweb.profilemanager.common.bean.rule.SyncStateBean
'||'import com.engiweb.profilemanager.common.bean.event.EventTargetBean
'||'import com.engiweb.profilemanager.common.ruleengine.action.ExtRoleAction
'||'import com.engiweb.profilemanager.common.ruleengine.action.RightsAction
'||'import com.ibm.igi.ib.wrapper.RightsCnt
'||'import java.util.List
'||'import java.util.Calendar
'||'import java.text.SimpleDateFormat
'||'import java.util.Iterator
'||'import java.util.HashMap
'||'import com.engiweb.pm.entity.BeanList
'||'import java.util.Set
'||'import com.engiweb.profilemanager.backend.utility.IBRestClient
'||'import com.engiweb.rpd.backend.business.direct.DomainDirect
'||'import com.engiweb.rpd.backend.business.direct.TaskDirect
'||'import com.engiweb.rpd.backend.business.direct.EntitlementDirect
'||'import com.engiweb.rpd.common.bean.DomainBean
'||'import com.engiweb.rpd.common.bean.EnvironmentBean
'||'import com.engiweb.rpd.common.bean.TaskBean
'||'
'||'global com.engiweb.profilemanager.backend.dao.db.SQLH sql
'||'global com.engiweb.logger.impl.Log4JImpl logger
'||'
';
 
  fr_id         number(16);
  fr_name       varchar2(256) := 'Create a new role - with Dn';
  fr_desc       varchar2(512) := '[ V1.0 - 2018-12-01 ]- roleDn=event.getAttr20()';
  
  fr_lob        clob := 'rule "Create a new role - with Dn"
'||'when
'||'    event : EventTargetBean(  )
'||'    eStateBean : EntStateBean(  )
'||'then
'||'// [ V1.0 - 2018-12-01 ]
'||'  logger.info("step1");
'||'  EntitlementBean entitlementBean = eStateBean.getMaster();
'||'
'||'  ExternalRoleDirect externalDirect = new ExternalRoleDirect();
'||'
'||'  if (entitlementBean.getId() != null & entitlementBean.getId() > 0) {
'||'    logger.info("step2 " + entitlementBean.getId());
'||'    // role already exist. nothing to do
'||'    externalDirect.updateExtRole(entitlementBean, sql);
'||'    return;
'||'  }
'||'
'||'  ApplicationDirect applicationDirect = new ApplicationDirect();
'||'
'||'  FunctionalityTypeBean permissionType = new FunctionalityTypeBean();
'||'  permissionType.setName(entitlementBean.getFunctionalityType_name());
'||'  permissionType.setId(entitlementBean.getFunctionalityType_id());
'||'  permissionType.setApplication_id(entitlementBean.getApplication_id());
'||'  permissionType.setApplication_name(entitlementBean.getApplication_name());
'||'
'||'  permissionType = (FunctionalityTypeBean) applicationDirect.checkAB(permissionType, false, sql);
'||'
'||'  if (permissionType.getId() == null || permissionType.getId() < 1) {
'||'    // permission type does not exit. we add it
'||'    permissionType = (FunctionalityTypeBean) applicationDirect.insertFuntionalityType(permissionType, sql);
'||'    entitlementBean.setFunctionalityType_id(permissionType.getId());
'||'  }
'||'
'||'  // Set the DN. The event.attr20 is mapped to entitlement bean is attr5.
'||'  if (event.getAttr20() != null) {
'||'    entitlementBean.setAttr5(event.getAttr20());
'||'  }
'||'  entitlementBean = applicationDirect.insertExternalRole(entitlementBean, sql);
'||'  eStateBean.setMaster(entitlementBean);
'||'
'||'  BeanList<EntitlementBean> bl = new BeanList<EntitlementBean>();
'||'  bl.add(entitlementBean);
'||'  applicationDirect.fulfillEntitlement(bl, sql);
'||'end
'||'
';

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
	
	update flow set flow_lob = f_lob where id = f_id;
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 0 ) then
    select flow_rule_seq.nextval into fr_id from dual;
    insert into flow_rule ( id, flow, name, description, rule_lob, ideas_module )
    values ( fr_id, f_id, fr_name, fr_desc, fr_lob, im_id );
  else
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );

    update flow_rule set description = fr_desc where id = fr_id;

    update flow_rule set rule_lob = fr_lob where id = fr_id;
  end if;

end;
/
commit;
set define on
