declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE DEVICE_FEATURE_SETTINGS
  (
    ID                           NUMBER(16)  NOT NULL,
    FEATURE_ENABLED              NUMBER(1)   DEFAULT 0 NOT NULL,
    MOBILE_ACCOUNT_NAME          VARCHAR2(256),
    MOBILE_FEATURE_VERSION       VARCHAR2(20),
    OIDC_TOKEN_GENERATE_URL      VARCHAR2(512),
    OIDC_TOKEN_REGENERATE_URL    VARCHAR2(512),
    OIDC_INVALIDATE_URL          VARCHAR2(512),
    EXTERNAL_URL                 VARCHAR2(512),
    QR_TOKEN_VALIDITY            NUMBER(16),
    OIDC_ACCESS_TOKEN_VALIDITY   NUMBER(16),
    OIDC_REFRESH_TOKEN_VALIDITY  NUMBER(16)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE DEVICE_FEATURE_SETTINGS
    ADD CONSTRAINT DEVICE_FEATURE_SETTINGS_PK PRIMARY KEY (ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON DEVICE_FEATURE_SETTINGS TO IDEAS;
GRANT ALL ON DEVICE_FEATURE_SETTINGS TO IDEAS_CONNECTOR;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE DEVICE_FEATURE_SETTINGS_SEQ
    START WITH 1
    INCREMENT BY 1
    MINVALUE 1
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON DEVICE_FEATURE_SETTINGS_SEQ TO IDEAS;
GRANT ALL ON DEVICE_FEATURE_SETTINGS_SEQ TO IDEAS_CONNECTOR;
