declare
  stat        varchar2(2048);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE TABLE DEVICE_INFO
  (
	DEVICE_ID 			NUMBER(16) 		NOT NULL,
	USER_ID 			VARCHAR2(128) 	NOT NULL,
	QR_TOKEN 			VARCHAR2(32) 	NOT NULL,
	QR_GENERATION_TIME 	NUMBER(16) 		NOT NULL,
	OIDC_ACCESS_TOKEN 	VARCHAR2(1024) 	NOT NULL,
	OIDC_REFRESH_TOKEN 	VARCHAR2(255) 	NOT NULL,
	OIDC_TOKEN_EXPIRY 	NUMBER(10) 		NOT NULL,
	DEVICE_STATE 		NUMBER(16) 		NOT NULL,
	APPLICATION_VERSION VARCHAR2(24),
	FINGERPRINT_SUPPORT NUMBER(1),
	FRONTCAMERA_SUPPORT NUMBER(1),
	FACE_SUPPORT 		NUMBER(1),
	PLATFORM_TYPE 		VARCHAR2(16),
	DEVICE_NAME 		VARCHAR2(255) 	NOT NULL,
	DEVICE_TYPE 		VARCHAR2(16),
	APPLICATION_ID 		VARCHAR2(40),
	DEVICE_UUID 		VARCHAR2(40),
	OS_VERSION 			VARCHAR2(24),
	VERIFY_SDK_VERSION 	VARCHAR2(24),
	PUSHTOKEN 			VARCHAR2(32)
  )
  TABLESPACE &DATA_TABLESPACE
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-02260); -- PK already defined

begin
  stat := '
  ALTER TABLE DEVICE_INFO
    ADD CONSTRAINT DEVICE_INFO_PK PRIMARY KEY (DEVICE_ID)
    USING INDEX TABLESPACE &INDEX_TABLESPACE COMPUTE STATISTICS
  ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON DEVICE_INFO TO IDEAS;
GRANT ALL ON DEVICE_INFO TO IDEAS_CONNECTOR;

declare
  stat        varchar2(256);
  exception1  EXCEPTION;
  PRAGMA EXCEPTION_INIT(exception1,-00955); -- name is already used by an existing object

begin
  stat := '
  CREATE SEQUENCE DEVICE_INFO_SEQ
    START WITH 1
    INCREMENT BY 1
    MINVALUE 1
    MAXVALUE 999999999999999999999999999
    NOCACHE
    NOCYCLE
    NOORDER
    ';

  execute immediate (stat);

exception
  when exception1 then null;

end;
/

GRANT ALL ON DEVICE_INFO_SEQ TO IDEAS;
GRANT ALL ON DEVICE_INFO_SEQ TO IDEAS_CONNECTOR;
